# ==================================================================
# Plugins::GForum::ForumImage - Auto Generated Install Module
#
#   Plugins::GForum::ForumImage
#   Author  : Ivan Herger
#   Version : 1.0
#   Updated : Mon Dec 10 11:08:45 2001
#
# ==================================================================
#

package Plugins::GForum::ForumImage;
# ==================================================================
use strict;
use vars  qw/$VERSION $DEBUG $NAME $META/;
use GT::Base;
use GT::Plugins qw/STOP CONTINUE/;
use GForum qw/$IN $DB $CFG/;

$VERSION = '1.0';
$DEBUG   = 0;
$NAME    = 'ForumImage';
# Inhert from base class for debug and error methods
@Plugins::GForum::ForumImage::ISA = qw(GT::Base);

$META = {
    'prog_ver' => '1.0.0',
    'url' => 'http://www.iyengar-yoga.com/',
    'license' => 'GPL',
    'description' => 'The "ForumImage" plugin makes it possible to add an image for each forum. You can store the image name, height and width. They can be accessed through <%forum_image%>, <%forum_image_height%> and <%forum_image_width%>.    ',
    'author' => 'Ivan Herger',
    'version' => '1.0'
};


sub pre_install {
# -------------------------------------------------------------------
# This function displays an HTML formatted message that will display
# to the user any instructions/information before they install
# the plugin.
#
    my $inst_msg = 'The ForumImage plugin will allow you to add an image to every category of your forum. It will create three fields in the "Forum" table.';

    return $inst_msg;
}

sub pre_uninstall {
# -------------------------------------------------------------------
# This function displays an HTML formatted message that will display
# to the user any instructions/information before they remove the
# plugin.
#
    my $uninst_msg = 'You are about to uninstall the "ForumImage Plugin." That means that three fields (and all the data stored in them) in the "Forum" table will be deleted (forum_image, forum_image_height, forum_image_width). ';

    return $uninst_msg;
}

sub install {
# -------------------------------------------------------------------
# This function does the actual installation. It's first argument is
# a plugin manager which you can use to register hooks, install files,
# add menu options, etc. The second argument is a GT::Tar object which
# you can use to access any files in your plugin module.
#
# You should return an HTML formatted string that will be displayed 
# to the user.
#
# If there is an error, return undef, and set the error message in
# $Plugins::GForum::ForumImage::error
#
    my ($mgr, $tar) = @_;

    my $editor = $DB->editor ('Forum');

    $editor->add_col ('forum_image', { 
                form_display => 'Image File Name',
                form_size => '30',
                form_type => 'TEXT',
                not_null => '0',
                size => 50, 
                type => 'VARCHAR' });

   $editor->add_col ('forum_image_height', { 
                form_display => 'Image Height',
                form_size => '4',
                form_type => 'INT',
                not_null => '0',
                size => 4, 
                type => 'INT' });

   $editor->add_col ('forum_image_width', { 
                form_display => 'Image Width',
                form_size => '4',
                form_type => 'INT',
                not_null => '0',
                size => 4, 
                type => 'INT' });
    

    return "The plugin has been successfully installed!";
}

sub uninstall {
# -------------------------------------------------------------------
# This function removes the plugin. It's first argument is
# also a plugin manager which you can use to register hooks, install files,
# add menu options, etc. You should return an HTML formatted string
# that will be displayed to the user.
#
# If there is an error, return undef, and set the error message in
# $Plugins::GForum::ForumImage::error
#
    my $mgr = shift;

    my $editor = $DB->editor ('Forum');

    $editor->drop_col ('forum_image');
    $editor->drop_col ('forum_image_height');
    $editor->drop_col ('forum_image_width');

    return "The plugin has been successfully removed!";
}

1;
